<?php
require_once("../includes.inc");

function check_input($data)
{
    $data = trim($data);
    $data = stripslashes($data);
    $data = htmlspecialchars($data);
    return $data;
}

// Check to make sure we entered data correctly
if (preg_match("/\s/",$domain_name)) {
        die("There cannot be any spaces, tabs, or newlines in the domain name! Hit your BACK button to correct this.");
        }
// Check to make sure we entered digits only where applicable.
if ($quota_bytes != "NOQUOTA") {
	if (preg_match("/\D/",$quota_bytes)) {
        	die("Please enter numbers or NOQUOTA for the quota! Hit your BACK button to correct this.");
        	}
	$finalquota = ($quota_bytes * 1024 * 1024);
}

if (preg_match("/\D/",$accounts_num))
        {
        die ("Please enter numbers only for the max number of accounts!  Hit your BACK button to correct this.");
        }
if (preg_match("/\D/",$forwards_num))
        {
        die ("Please enter numbers only for the max number of forwards!  Hit your BACK button to correct this.");
        }
if (preg_match("/\D/",$alias_num))
        {
        die ("Please enter numbers only for the max number of aliases! Hit your BACK button to correct this.");
        }
if (preg_match("/\D/",$autorespond_num))
        {
        die ("Please enter numbers only for the max number of autoresponders!  Hit your BACK button to correct this.");
        }
if (preg_match("/\D/",$mailinglist_num))
        {
        die ("Please enter numbers only for the max number of mailing lists! Hot your BACK button to correct this.");
        }

$domain_name = check_input($_POST["domain_name"]);
$postmaster_password = check_input($_POST["postmaster_password"]);
$accounts_num = check_input($_POST["accounts_num"]);
$forwards_num = check_input($_POST["forwards_num"]);
$alias_num = check_input($_POST["alias_num"]);
$autorespond_num = check_input($_POST["autorespond_num"]);
$mailinglist_num = check_input($_POST["mailinglist_num"]);
$quota_bytes = check_input($_POST["quota_bytes"]);
$bounce_unknown = check_input($_POST["bounce_unknown"]);
$dis_pop = check_input($_POST["dis_pop"]);
$dis_imap = check_input($_POST["dis_imap"]);
$dis_dialup = check_input($_POST["dis_dialup"]);
$dis_changepw = check_input($_POST["dis_changepw"]);
$dis_webacc = check_input($_POST["dis_webacc"]);
$dis_relay = check_input($_POST["dis_relay"]);

if (!isset($_POST['submit'])) { // if page is not already submitted, display the form
?>

<html>
<head>
<title>Add a Domain</title>
</head>
<body>
<form method="post" action="<?php echo $PHP_SELF;?>">
Domain Name:<input type="text" size="30" maxlength="80" name="domain_name"><br />
Postmaster's Password:<input type="text" size="20" maxlength="30" name="postmaster_password" value=<?$postmaster_password_default?> <?php echo $postmaster_password_default; ?>><br />
Maximum Number of Accounts Allowed:<input type="text" size="8" maxlength="8" name="accounts_num" value=<?$accounts_num_default?> <?php echo $accounts_num_default; ?>><br />
Maximum Number of Forwards Allowed:<input type="text" size="8" maxlength="8" name="forwards_num" value=<?$forwards_num_default?> <?php echo $forwards_num_default; ?>><br />
Maximum Number of Aliases Allowed:<input type="text" size="8" maxlength="8" name="alias_num" value=<?$alias_num_default?> <?php echo $alias_num_default; ?>><br />
Maximum Number of Auto Responders Allowed:<input type="text" size="8" maxlength="8" name="autorespond_num" value=<?$autorespond_num_default?> <?php echo $autorespond_num_default; ?>><br />
Maximum Number of Mailing Lists Allowed:<input type="text" size="8" maxlength="8" name="mailinglist_num" value=<?$mailinglist_num_default?> <?php echo $mailinglist_num_default; ?>><br />
Postmaster's Quota in megabytes (NOQUOTA for no quota):<input type="text" size="13" maxlength="18" name="quota_bytes" value=<?$quota_default?> <?php echo $quota_default; ?>><br />
<p>
Bad Recipient Handling:<br />
Bounce if no match:<input type="radio" value="bounce_no_match" name="bounce_unknown" checked><br />
Set Postmaster as Catchall:<input type="radio" value="catchall" name="bounce_unknown"><br />
<p>
Restrictions:<br />
Disable POP Access:<input type="checkbox" value="1" name="dis_pop"><br />
Disable IMAP Access:<input type="checkbox" value="1" name="dis_imap"><br />
Disable Dialup Access:<input type="checkbox" value="1" name="dis_dialup"><br />
Disable Change Password:<input type="checkbox" value="1" name="dis_changepw"><br />
Disable Web Access:<input type="checkbox" value="1" name="dis_webacc"><br />
Disable Email Relay:<input type="checkbox" value="1" name="dis_relay"><br />

<input type="submit" value="submit" name="submit">
</form>
<?
} else {

// Let's add some error checking to the form to make sure all fields are filled...
if ((!$domain_name) || (!$postmaster_password) || (!$accounts_num) || (!$forwards_num) || (!$alias_num) || (!$autorespond_num) || (!$mailinglist_num) || (!$quota_bytes))
	{
	print "You did not fill in all fields.  Hit the BACK button in your browser and fill in all the fields!";
	}
else {


	if ($bounce_unknown == "bounce_no_match")
	{
		$command="/usr/share/toaster/qcontrol/utils/qcontrol add_domain -b $domain_name $postmaster_password";
		$output=shell_exec($command."");
		print "<pre>$output</pre>\n";
		if ($output == "You cannot add more than 1 domain with the Personal Edition.\n") {
		        die();
        	}

	}
	else
	{
	$command="/usr/share/toaster/qcontrol/utils/qcontrol add_domain -e postmaster $domain_name $postmaster_password";
	$output=shell_exec($command."");
	print "<pre>$output</pre><br>";
	if ($output == "You cannot add more than 1 domain with the Personal Edition.\n") {
	        die();
        }

	}

if ($dis_pop || $dis_imap || $dis_dialup || $dis_changepw || $dis_webacc || $dis_relay == "1") {
$command1="/usr/share/toaster/qcontrol/utils/qcontrol set_ops -g ";
	if ($dis_pop == "1") {
		$command1 .= "p";
	}
	if ($dis_imap == "1") {
		$command1 .= "i";
	}
	if ($dis_dialup == "1") {
		$command1 .= "u";
	}
	if ($dis_changepw == "1") {
		$command1 .= "d";
	}
	if ($dis_webacc == "1") {
		$command1 .= "w";
	}
	if ($dis_relay == "1") {
		$command1 .= "r";
	}
$command1 .= " ";
}
else{
	$command1="/usr/share/toaster/qcontrol/utils/qcontrol set_ops ";
}

if ($quota_bytes == "NOQUOTA") {
	$command2="/usr/share/toaster/qcontrol/utils/qcontrol set_ops -Q 0 -q 0 -m 0 -M 0 $domain_name";
	}
else {
	$finalquota = ($quota_bytes * 1024 * 1024);
	$command2="/usr/share/toaster/qcontrol/utils/qcontrol set_ops -q $finalquota $domain_name";
}


$command1 .= "-P $accounts_num -A $alias_num -F $forwards_num -R $autorespond_num -L $mailinglist_num $domain_name";
$output1=shell_exec($command1."");
$output2=shell_exec($command2."");
print "<pre>$output1</pre>\n";
print "<pre>$output2</pre>\n";
echo "<br><br><b>$domain_name</b> created!";
}

}

?> 
